We know , Knapsack problem is a classic dynamic programming problem , This paper summarizes and analyzes several types of knapsack problems ：

According to Baidu Encyclopedia , We can see the backpack problem (Knapsack problem) It's a kind of combinatorial optimization NP Problem completely . The problem can be described as ： Given a set of items , Each item has its own weight and price , Within the total weight limit , How do we choose , To maximize the total price of the item . The name of the problem comes from how to choose the most suitable item to put in a given backpack . Similar problems often arise in business 、 Combinatorial mathematics , Computational complexity theory 、 In the fields of cryptography and applied mathematics . The knapsack problem can also be described as The decisive question , That is, the total weight does not exceed W Under the premise of , Whether the total value can reach V？ It's in 1978 Year by year Merkle and Hellman Proposed .

In general , We can divide it into the following types ：

**·01 knapsack problem **

**· Complete knapsack problem **

**· Multiple knapsack problem **

**· Combinatorial knapsack problem **

Let's solve it one by one , First, let's see the most basic **01 knapsack problem ：**

01 Backpack is to tell us that there is n Item , You can choose or not choose each item , At most once ;

Let's first consider the naive algorithm , That is, the method of violent exhaustion , But it's clear that this has 2^n A possibility , This is unacceptable . If we use dynamic programming here, we can effectively reduce the time complexity to O（NV）, Here we need to extract the goal and state in the problem space , So we define the state as ：

*dp[i][j] It means only the first i Consider putting or not putting this item in , The total volume does not exceed j when , The maximum value that can be achieved .*

Let's put all the dp Initialize to 0, Then we'll consider whether to load the second i Item , There are two possibilities ：

1. Do not load section i Item , be **dp[i][j] = dp[i-1][j];**

2. Load the second i In the case of an item ,**dp[i][j] = dp[i-1][j - v[i] ] + w[i];**

This is a dp[i][j] In the investigation, we found that i Two kinds of items Probably , So we can get the state transition equation as follows ：

*dp[i][j] = max(dp[i-1][j] , dp[i-1][j - v[i] ] + w[i] );*

and , We can find out ,dp[i][j] as for dp[i-1][0~j-1] of , So we can use spatial optimization, which is very commonly used in dynamic programming （ Scrolling array , The removed dp The first dimension of ）, Then in the first i Sublayer , If dp[j] Not updated , Namely dp[i-1][j], If it has been updated, it is dp[i][j] 了 , So we can find that after space optimization , We can't cover the loop of the previous layer , So enumerating volumes j You can only enumerate inversely when , This is to avoid taking the updated value and continuing to update the value of the same dimension ;

The core idea of dynamic programming is to avoid repeated calculation , The first i The maximum value obtained by loading or not loading an item can be completely determined by the former i-1 The maximum value of an item determines , The violence enumeration ignores this fact ！

Code ：

#include<bits/stdc++.h>

#define maxn 1010

using namespace std;

int v[maxn],w[maxn];

int f[maxn];

int n,m;

int main()

{

cin >> n >> m;

for (int i = 1; i <= n; i ++ ) cin >> v[i] >> w[i];

for(int i = 1;i<=n;i++)

for(int j = m;j>=v[i];j--)

f[j] = max(f[j - v[i]] + w[i], f[j]);

cout << f[m] << '\n';

return 0;

}

Next , We then consider the second knapsack problem, which is ** Complete knapsack problem **：

Complete knapsack problem and the above 01 The knapsack problem is different , Complete knapsack problem i This item has infinite reserves , You can take as much as you want ;

We have two common analytical ideas , First, we can talk to 01 Like the knapsack problem, first define the State ：

*dp[i][j] It means only the first i Consider putting or not putting this item in , The total volume does not exceed j when , The maximum value that can be achieved .*

But we are here to consider the second i Do you want to add one to this item When , We don't have to think about dp[i-1][j - v[i] ] , It's moving to dp[i][j - v[i] ] in , That is to say, after adding the second i Can I add the second item after this item i Commodity ;

We can also write ：

*dp[i][j] = max(dp[i-1][j] , dp[i-1][j - v[i] ] + w[i] , dp[i-1][j - 2*v[i] ] + 2*w[i] ……,dp[i-1][j - k*v[i] ] + k*w[i] )*

*dp[i][j - v[i] ] = max(dp[i-1][j - v[i] ] , dp[i-1][j - 2*v[i] ] + w[i] ……,dp[i-1][j - k*v[i] ] + (k-1)*w[i] )*

We can see that the red part above is only poor w[i], So we can write the state transition equation as ：

*dp[i][j] = min(dp[i][j - v[i] ] + w[i] , dp[i-1][j]);*

This is the first way of analysis , Next is the second way of analysis , Just put the above k List them one by one to get the best value , More trouble , So I won't repeat it here ！

Code ：

#include<bits/stdc++.h>

#define maxn 1010

using namespace std;

int v[maxn],w[maxn];

int f[maxn];

int main()

{

int n,m;

cin >> n >> m;

for(int i = 1;i<=n;i++) cin >> v[i] >> w[i];

for(int i = 1;i<=n;i++)

for(int j = v[i];j<=m;j++)

f[j] = max(f[j],f[j - v[i]] + w[i]);

cout << f[m] << '\n';

return 0;

}

Space optimization can also be carried out here , It's the same way , But we found that because of our state transition equation , Yes dp[i][j - v[i] ], So we can use the updated value to update the value of the same dimension , So here we do not need to carry out reverse enumeration, we can directly carry out forward circular enumeration ;

The next question is called ** Multiple knapsack problem **, It's because of the second i This item is neither like 01 There is a limit of one item in the backpack , There is no such thing as the complete knapsack problem in which you can choose an unlimited number of pieces , According to the complexity of the data , There are two ways of analysis ：

················· To be continued ···············